<?php
// Set your CoinPayments API credentials
$public_key = '4328c8929813f8061ac4d10e13f6f7a18aadd2e957457225f8c4c5d0cf17a00c';
$private_key = '5D8F5C4af5Eb2d3c95D164Ddf3302Ecd8f1cdD5b81883a35b90705D43606D551';

// Validate the form inputs
if (!isset($_POST['amount']) || !isset($_POST['currency']) || !isset($_POST['buyer_email']) || !isset($_POST['plan_name']) || !isset($_POST['plan_duration'])) {
    die("Required data not provided.");
}

$amount = $_POST['amount']; // Amount from form input
$currency2 = $_POST['currency']; // Cryptocurrency from form input
$buyer_email = $_POST['buyer_email']; // Buyer email from form input
$plan_name = $_POST['plan_name']; // Plan name from form input
$plan_duration = $_POST['plan_duration']; // Plan duration from form input

// Prepare API request data
$request = [
    'version' => 1,
    'cmd' => 'create_transaction',
    'key' => $public_key,
    'amount' => $amount,
    'currency1' => 'USD',
    'currency2' => $currency2, // Dynamic cryptocurrency
    'buyer_email' => $buyer_email, // Dynamic buyer email
    'plan_name' => $plan_name, // Dynamic plan name
    'plan_duration' => $plan_duration, // Dynamic plan duration
    'purchase_date' => date('Y-m-d'), // Use current date
    'expired_date' => calculateExpiredDate(date('Y-m-d'), $plan_duration), // Calculate expiration date
    'ipn_url' => 'https://deentime.app/coinpayment/ok/ipn_handler.php' // Your IPN handler URL
];
file_put_contents('request_log.txt', print_r($request, true), FILE_APPEND);

// Function to calculate expiration date based on purchase date and duration
function calculateExpiredDate($purchase_date, $duration) {
    $purchase_date_timestamp = strtotime($purchase_date);
    return date('Y-m-d', strtotime("+$duration days", $purchase_date_timestamp));
}

// Generate HMAC for API request authentication
$hmac = hash_hmac('sha512', http_build_query($request), $private_key);

// Initiate cURL session
$ch = curl_init('https://www.coinpayments.net/api.php');
curl_setopt($ch, CURLOPT_POST, true);
curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($request)); // Ensure data is sent in URL-encoded format
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_HTTPHEADER, [
    'HMAC: '.$hmac,
    'Content-Type: application/x-www-form-urlencoded'
]);

// Execute cURL request and handle response
$response = curl_exec($ch);
curl_close($ch);

if ($response !== false) {
    // Decode the response to a PHP array
    $decoded_response = json_decode($response, true);
    
    // Output the response in JSON format
    header('Content-Type: application/json');
    echo json_encode($decoded_response, JSON_PRETTY_PRINT);

} else {
    // If cURL request failed, return an error message
    $error_response = [
        'error' => true,
        'message' => 'Failed to connect to CoinPayments API.'
    ];

    // Output the error response in JSON format
    header('Content-Type: application/json');
    echo json_encode($error_response, JSON_PRETTY_PRINT);
}
?>
