<?php

// Define your API key
$apiKey = 'aef78d7e11e48fd0c8b9cc7fed460bb1d5e22d26';

// Get the API key from the request headers
$headerApi = isset($_SERVER['HTTP_RT_UDDOKTAPAY_API_KEY']) ? $_SERVER['HTTP_RT_UDDOKTAPAY_API_KEY'] : null;

// Get the request body
$rawData = file_get_contents('php://input');

// Verify the API key
if ($headerApi !== $apiKey) {
    http_response_code(401); // Unauthorized
    echo json_encode(["error" => "Unauthorized Action"]);
    exit();
}

// Parse the JSON data
$data = json_decode($rawData, true);

// Check if JSON data was successfully parsed
if ($data === null) {
    http_response_code(400); // Bad Request
    echo json_encode(["error" => "Invalid JSON data"]);
    exit();
}

// Prepare log entry
$logEntry = [
    'timestamp' => date('Y-m-d H:i:s'),
    'data' => $data
];

// Convert log entry to JSON
$logJson = json_encode($logEntry, JSON_PRETTY_PRINT);

// Append to log.txt
file_put_contents('log.txt', $logJson . PHP_EOL, FILE_APPEND | LOCK_EX);

// Respond to the request
echo json_encode(["status" => "success", "message" => "Webhook data received and logged."]);

?>
